/**************************************************************************

Author: DFRobot/free

Date:2015-02-07

Description:his is to measure the quality by using the half duplex communication boat(Apc220).
Water quality parameters including PH, temperature and TDS.
This is the boat control and water quality of the receiving end.

**************************************************************************/


#include <SPI.h>
#include <SD.h>//SD
#include <SPIFlash.h>//SD
#include <DmDrawBmpFromSdCard.h>//SD
#include <DmTftRa8875.h>
#include <DmTouch.h>
#include <utility/DmTouchCalibration.h>
#include <DFRobot_utility.h>
#include <utility/SerialProtocol.h>

#define TFT_CS  10
#define SD_CS   8
#define F_CS    6
#define T_CS    4
#define T_IRQ   2
#define T_IRQ   3


DmTftRa8875 tft = DmTftRa8875();
DmTouch dmTouch = DmTouch(DmTouch::DM_TFT43_108, DmTouch::Auto, true);
DmTouchCalibration calibration = DmTouchCalibration(&tft, &dmTouch);
DmDrawBmpFromSdCard sdCardImage = DmDrawBmpFromSdCard();
bool calibrated = false;


 uint8_t squarePressed = 0;             //for data receive
 bool touched;
 uint16_t posX, posY;
  
  
 /*This class is to make the sensor data received over*/
struct mytype {  
  float PH;
  float T ; 
  long TDS;
 uint8_t sum;
};
struct mytype data;


void setup() {                                       // Set CS SPI pin HIGH for all SPI units, so they don't interfere
  pinMode(TFT_CS, OUTPUT);
  pinMode(T_CS, OUTPUT);
  pinMode(SD_CS, OUTPUT);
  pinMode(F_CS, OUTPUT);
  digitalWrite(TFT_CS, HIGH);
  digitalWrite(T_CS, HIGH);
  digitalWrite(SD_CS, HIGH);
  digitalWrite(F_CS, HIGH);
  
  Serial.begin(19200);                            //'RA8875_480x272' or 'RA8875_800x480'
  tft.init(RA8875_800x480);
  dmTouch.init();
  dmTouch.setCalibrationMatrix(calibration.getDefaultCalibrationData((int)DmTouch::DM_TFT43_108));
  tft.backlightOn(true); // Turn on backlight
  tft.backlightAdjust(255);   // default value max  
  
  
  int x=540;
  int y=200;
  int width=100;
  int high=70;
  int interval=65;
  int a=30;
  
  if (!SD.begin(SD_CS)) {sdCardImage.drawImage("love.bmp", tft, 0,0);           //  sdCardImage.drawImage("sky.bmp", tft, 0,0);
   tft.fillRectangle(x, (y-interval-high), x+width, (y-interval), BLUE);
  tft.fillRectangle(x, (y+interval+high), x+width,  (y+interval+2*high),  BLUE);
  tft.fillRectangle( (x-width-interval+a), y,(x-interval+a),  (y+high),  BLUE);
  tft.fillRectangle( (x+2*interval), y, (x+2*interval+width),  (y+high),  BLUE);
  tft.fillCircle(200, 220, 70, BLUE   );
  tft.fillCircle(130, 120, 17, BLUE   );
  tft.fillCircle(180, 105, 20, BLUE   );
   tft.fillCircle(250, 100, 30, BLUE   );
   tft.drawString(35, 420, "Facing the sea with spring flowers blossoming");
   
   tft.drawString(35, 320, "PH:");
   tft.drawString(35, 350, "T:"); 
   tft.drawString(35, 380, "TDS:");
   }
    while (!Serial) {
    ; // wait for serial port to connect. Needed for Leonardo only
  }
}

void loop() {
  /*The display part*/
   int leng = serialRead (Serial, (uint8_t*)&data, sizeof (data), 10);
   if (leng){
    if (leng != sizeof (data)){
//      Serial.println ("-------------- data length error");
   } 
else {
    uint8_t sum = checksum (&data, sizeof (data)-1);
    if (sum != data.sum){
//      Serial.println ("----------------------check error");

    } else {
      
      float PHA=(data.PH-int(data.PH))*10;
      int PHB=(PHA-int(PHA))*10;
      tft.drawNumber(70, 320, data.PH ,2, 0);
      tft.drawString(100, 320, ".");
      tft.drawNumber(110, 320, PHA ,1, 0);
      tft.drawNumber(120, 320,PHB ,1, 0);
      
      float T1=(data.T-int(data.T))*10;
      int T2=(T1-int(T1))*10;
      tft.drawNumber(70, 350, data.T ,2, 0);// 2 Represents the display number number
      tft.drawString(100, 350, ".");
      tft.drawNumber(110, 350, T1 ,1, 0);
      tft.drawNumber(120, 350,T2 ,1, 0);  
      
      tft.drawNumber(70, 380, data.TDS ,5, 0);  
    }
  }
  }
  
  
  


/*Touch sensing part*/
   delay(10);
   int x=540;
  int y=200;
  int width=100;
  int high=60;
  int interval=65;
  int a=30;
  uint8_t squarePressed = 0;
  bool touched;
  uint16_t posX, posY;
  

//   if(!squarePressed) {    
//    if (dmTouch.isTouched()) {
      dmTouch.readTouchData(posX, posY, touched);     
       if (posX >= x && posX <= x+width && posY >= (y-interval-high) && posY <= (y-interval)) 
         {   Serial.write('A');   delay(100);}//forward
       if (posX >= x && posX <= x+width && posY >= (y+interval+high) && posY <= (y+interval+2*high)) 
         { Serial.write('B');   delay(100); }//back
       if (posX >= (x-width-interval+a)&& posX <= (x-interval+a) && posY >= y && posY <= (y+high)) 
         { Serial.write('L');   delay(100);}//left
       if (posX >= (x+interval)&& posX <= (x+interval+width) && posY >= y && posY <= (y+high)) 
         { Serial.write('R');   delay(100); }//right
      if (posX >= 130&& posX <= 270 && posY>= 150&& posY <= 290) 
         { Serial.write('S');   delay(100); }//stop
    

}


uint8_t  checksum (struct mytype * theData, uint8_t theLeng){
  uint8_t sum = 0;
  for (int i=0; i< theLeng; i++){
    sum += ((uint8_t*)theData)[i];
  }
  return sum;
}


